function [L, P] = evalLikelihood(Xsource, GMMsource, Gconst)
% function [L, P] = evalLikelihood(Xsource, GMMsource, Gconst)
%
% Maximization step
% Version 1.0
% copyright by Hadas Benisty (2012)
% Technion
% contact hadasbe@tx.technion.ac.il
%
Ns = size(Xsource, 2);
pxt=zeros([1,Ns]);
m = length(GMMsource);
for i=1:m
    ai=GMMsource(i).a;
    ui=GMMsource(i).u;
    Ei=GMMsource(i).E;
    dEi=1/sqrt(det(Ei));
    iEi=inv(Ei);
    for t=1:Ns
        P(i,t)=ai*dEi*exp(-0.5*transpose(Xsource(:,t)-ui)*iEi*(Xsource(:,t)-ui));
        pxt(t)=pxt(t)+Gconst*P(i,t);
    end;
end;
L=sum(log(pxt));
Psum=sum(P,1);
for i=1:m
    P(i,:)=P(i,:)./Psum;
end;
end