function P = expectationStep(GMMparams, Z)
% function P = expectationStep(GMMparams, Z)
%
% Version 1.0
% copyright by Hadas Benisty (2012)
% Technion
% contact hadasbe@tx.technion.ac.il

m = length(GMMparams);
Ns = size(Z, 2);
P=zeros(m,Ns);
for i=1:m
    % extract
    ai=GMMparams(i).a; % weights of GMMs
    ui=GMMparams(i).u; % mean vectors
    Ei=GMMparams(i).E; % variance matrices
    dEi=1/sqrt(det(Ei)); % sqrt{|\Sigma_m|}
    iEi=inv(Ei);
    for t=1:Ns
        P(i,t)=ai*dEi*exp(-0.5*transpose(Z(:,t)-ui)*iEi*(Z(:,t)-ui));
    end;
end;
Psum=sum(P);
for i=1:m
    P(i,:)=P(i,:)./Psum;
end;
end