function lam_final = gridSearchSol(b_tild_partial, Da,Db,A,B,al2,Xls,b,m,s,e)

% function lam_final = gridSearchSol(b_tild_partial, Da,Db,A,B,al2,Xls,b,m,s,e)
% A grid search solution for the constrained optimization problem of CGMM
%
% Version 1.0
% copyright by Hadas Benisty (2012)
% Technion
% contact hadasbe@tx.technion.ac.il


lam_v =linspace(s,e,5000);
for v=1:length(lam_v)
    lam = lam_v(v);
    xi_tild = diag(Da./(Da.^2+lam *Db.^2))*b_tild_partial;
    xi = (((Xls')\(xi_tild)));
    h1(v) = ((A*xi-b)'*(A*xi-b));
    h2(v)=   ((B*xi)'*B*xi);
    h(v) =  h1(v) +lam*h2(v);
    phi_v(v) = b_tild_partial'*diag((Da.*Db./(Da.^2+lam*Db.^2)).^2)*b_tild_partial;
    t(v) = all(xi(m+1:end)>0);
end

[a,b]=min(abs(phi_v-al2));


lam_final0= lam_v(b);
lam_v =linspace(lam_final0*1.1,lam_final0*.9,5000);
for v=1:length(lam_v)
    lam = lam_v(v);
    xi_tild = diag(Da./(Da.^2+lam *Db.^2))*b_tild_partial;
    xi = (((Xls')\(xi_tild)));
    h1(v) = ((A*xi-b)'*(A*xi-b));
    h2(v)=   ((B*xi)'*B*xi);
    h(v) =  h1(v) +lam*h2(v);
    phi_v(v) = b_tild_partial'*diag((Da.*Db./(Da.^2+lam*Db.^2)).^2)*b_tild_partial;
    t(v) = all(xi(m+1:end)>0);
end


[a,b]=min(abs(phi_v-al2));
lam_final= lam_v(b);