function GMMparams = initEMkmeans(X, m, pert, diagonalCov)

% function GMMparams = initEMkmeans(X, m, pert, diagonalCov)
% Initialize GMM using kmeans 
% Version 1.0
% copyright by Hadas Benisty (2012)
% Technion
% contact hadasbe@tx.technion.ac.il
%


[ord, Ns] = size(X);
[c,c0]=clustkmeans(X,m);

GMMparams(1:m)=struct('a',0,'u',zeros(ord,1),'E',zeros(ord));
for i=1:m
    indi=find(c==i);
    subX=X(:,indi);
    subN=length(indi);
    GMMparams(i).a=subN/Ns;
    GMMparams(i).u=X(:,c0(i));
    
    Ei=zeros(ord);
    for k=1:subN
        v=subX(:,k)-GMMparams(i).u;
        Ei=Ei+v*transpose(v);
    end;
    if diagonalCov
        GMMparams(i).E=((1/subN)*Ei+pert*eye(ord)).*eye(ord);
    else
        GMMparams(i).E=(1/subN)*Ei+pert*eye(ord);
    end
end
end