function GMMparams = maximizationStep(GMMparams, P, X, pert, diagonalCov)

% function  GMMparams = maximizationStep(GMMparams, P, X, pert, diagonalCov)
% Maximization step
% Version 1.0
% copyright by Hadas Benisty (2012)
% Technion
% contact hadasbe@tx.technion.ac.il
%
[ord, Ns] = size(X);
m = length(GMMparams);
for i=1:m % Evaluate teh new weights
    GMMparams(i).a=(1/Ns)*sum(P(i,:));
end;
for i=1:m % Evaluate teh new mean vectors
    ui=zeros(ord,1);
    for t=1:Ns
        ui=ui+P(i,t)*X(:,t);
    end;
    GMMparams(i).u=ui*(1/(Ns*GMMparams(i).a));
end;
for i=1:m % Evaluate teh new cov. matrices
    Ei=zeros(ord,ord);
    for t=1:Ns
        Ei=Ei+P(i,t)*(X(:,t)-GMMparams(i).u)*transpose(X(:,t)-GMMparams(i).u);
    end;
    if diagonalCov
        GMMparams(i).E=(Ei*(1/(Ns*GMMparams(i).a))+pert*eye(ord)).*eye(ord);
    else
        GMMparams(i).E=Ei*(1/(Ns*GMMparams(i).a))+pert*eye(ord);
    end
end;
end